diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index 761218f0574..dbee60c1be3 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -528,7 +528,7 @@ AppendAttributeTuples(Relation indexRelation, int numatts)
 	/*
 	 * open the attribute relation and its indexes
 	 */
-	pg_attribute = heap_open(AttributeRelationId, RowExclusiveLock);
+	pg_attribute = table_open(AttributeRelationId, RowExclusiveLock);
 
 	indstate = CatalogOpenIndexes(pg_attribute);
 
@@ -548,7 +548,7 @@ AppendAttributeTuples(Relation indexRelation, int numatts)
 
 	CatalogCloseIndexes(indstate);
 
-	heap_close(pg_attribute, RowExclusiveLock);
+	table_close(pg_attribute, RowExclusiveLock);
 }
 
 /* ----------------------------------------------------------------
@@ -626,7 +626,7 @@ UpdateIndexRelation(Oid indexoid,
 	/*
 	 * open the system catalog index relation
 	 */
-	pg_index = heap_open(IndexRelationId, RowExclusiveLock);
+	pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
 	/*
 	 * Build a pg_index tuple
@@ -668,7 +668,7 @@ UpdateIndexRelation(Oid indexoid,
 	/*
 	 * close the relation and free the tuple
 	 */
-	heap_close(pg_index, RowExclusiveLock);
+	table_close(pg_index, RowExclusiveLock);
 	heap_freetuple(tuple);
 }
 
@@ -766,7 +766,7 @@ index_create(Relation heapRelation,
 	relkind = partitioned ? RELKIND_PARTITIONED_INDEX : RELKIND_INDEX;
 	is_exclusion = (indexInfo->ii_ExclusionOps != NULL);
 
-	pg_class = heap_open(RelationRelationId, RowExclusiveLock);
+	pg_class = table_open(RelationRelationId, RowExclusiveLock);
 
 	/*
 	 * The index will be in the same namespace as its parent table, and is
@@ -840,7 +840,7 @@ index_create(Relation heapRelation,
 					(errcode(ERRCODE_DUPLICATE_TABLE),
 					 errmsg("relation \"%s\" already exists, skipping",
 							indexRelationName)));
-			heap_close(pg_class, RowExclusiveLock);
+			table_close(pg_class, RowExclusiveLock);
 			return InvalidOid;
 		}
 
@@ -945,7 +945,7 @@ index_create(Relation heapRelation,
 					   reloptions);
 
 	/* done with pg_class */
-	heap_close(pg_class, RowExclusiveLock);
+	table_close(pg_class, RowExclusiveLock);
 
 	/*
 	 * now update the object id's of all the attribute tuple forms in the
@@ -1404,7 +1404,7 @@ index_constraint_create(Relation heapRelation,
 		Form_pg_index indexForm;
 		bool		dirty = false;
 
-		pg_index = heap_open(IndexRelationId, RowExclusiveLock);
+		pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
 		indexTuple = SearchSysCacheCopy1(INDEXRELID,
 										 ObjectIdGetDatum(indexRelationId));
@@ -1433,7 +1433,7 @@ index_constraint_create(Relation heapRelation,
 		}
 
 		heap_freetuple(indexTuple);
-		heap_close(pg_index, RowExclusiveLock);
+		table_close(pg_index, RowExclusiveLock);
 	}
 
 	return referenced;
@@ -1479,7 +1479,7 @@ index_drop(Oid indexId, bool concurrent)
 	 */
 	heapId = IndexGetRelation(indexId, false);
 	lockmode = concurrent ? ShareUpdateExclusiveLock : AccessExclusiveLock;
-	userHeapRelation = heap_open(heapId, lockmode);
+	userHeapRelation = table_open(heapId, lockmode);
 	userIndexRelation = index_open(indexId, lockmode);
 
 	/*
@@ -1556,7 +1556,7 @@ index_drop(Oid indexId, bool concurrent)
 		SET_LOCKTAG_RELATION(heaplocktag, heaprelid.dbId, heaprelid.relId);
 		indexrelid = userIndexRelation->rd_lockInfo.lockRelId;
 
-		heap_close(userHeapRelation, NoLock);
+		table_close(userHeapRelation, NoLock);
 		index_close(userIndexRelation, NoLock);
 
 		/*
@@ -1599,7 +1599,7 @@ index_drop(Oid indexId, bool concurrent)
 		 * conflicts with existing predicate locks, so now is the time to move
 		 * them to the heap relation.
 		 */
-		userHeapRelation = heap_open(heapId, ShareUpdateExclusiveLock);
+		userHeapRelation = table_open(heapId, ShareUpdateExclusiveLock);
 		userIndexRelation = index_open(indexId, ShareUpdateExclusiveLock);
 		TransferPredicateLocksToHeapRelation(userIndexRelation);
 
@@ -1621,7 +1621,7 @@ index_drop(Oid indexId, bool concurrent)
 		/*
 		 * Close the relations again, though still holding session lock.
 		 */
-		heap_close(userHeapRelation, NoLock);
+		table_close(userHeapRelation, NoLock);
 		index_close(userIndexRelation, NoLock);
 
 		/*
@@ -1644,7 +1644,7 @@ index_drop(Oid indexId, bool concurrent)
 		 * leave nothing to chance and grab AccessExclusiveLock on the index
 		 * before the physical deletion.
 		 */
-		userHeapRelation = heap_open(heapId, ShareUpdateExclusiveLock);
+		userHeapRelation = table_open(heapId, ShareUpdateExclusiveLock);
 		userIndexRelation = index_open(indexId, AccessExclusiveLock);
 	}
 	else
@@ -1671,7 +1671,7 @@ index_drop(Oid indexId, bool concurrent)
 	/*
 	 * fix INDEX relation, and check for expressional index
 	 */
-	indexRelation = heap_open(IndexRelationId, RowExclusiveLock);
+	indexRelation = table_open(IndexRelationId, RowExclusiveLock);
 
 	tuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexId));
 	if (!HeapTupleIsValid(tuple))
@@ -1683,7 +1683,7 @@ index_drop(Oid indexId, bool concurrent)
 	CatalogTupleDelete(indexRelation, &tuple->t_self);
 
 	ReleaseSysCache(tuple);
-	heap_close(indexRelation, RowExclusiveLock);
+	table_close(indexRelation, RowExclusiveLock);
 
 	/*
 	 * if it has any expression columns, we might have stored statistics about
@@ -1720,7 +1720,7 @@ index_drop(Oid indexId, bool concurrent)
 	/*
 	 * Close owning rel, but keep lock
 	 */
-	heap_close(userHeapRelation, NoLock);
+	table_close(userHeapRelation, NoLock);
 
 	/*
 	 * Release the session locks before we go.
@@ -2120,7 +2120,7 @@ index_update_stats(Relation rel,
 	 * what's really important.
 	 */
 
-	pg_class = heap_open(RelationRelationId, RowExclusiveLock);
+	pg_class = table_open(RelationRelationId, RowExclusiveLock);
 
 	/*
 	 * Make a copy of the tuple to update.  Normally we use the syscache, but
@@ -2209,7 +2209,7 @@ index_update_stats(Relation rel,
 
 	heap_freetuple(tuple);
 
-	heap_close(pg_class, RowExclusiveLock);
+	table_close(pg_class, RowExclusiveLock);
 }
 
 
@@ -2350,7 +2350,7 @@ index_build(Relation heapRelation,
 		HeapTuple	indexTuple;
 		Form_pg_index indexForm;
 
-		pg_index = heap_open(IndexRelationId, RowExclusiveLock);
+		pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
 		indexTuple = SearchSysCacheCopy1(INDEXRELID,
 										 ObjectIdGetDatum(indexId));
@@ -2365,7 +2365,7 @@ index_build(Relation heapRelation,
 		CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
 
 		heap_freetuple(indexTuple);
-		heap_close(pg_index, RowExclusiveLock);
+		table_close(pg_index, RowExclusiveLock);
 	}
 
 	/*
@@ -3133,7 +3133,7 @@ validate_index(Oid heapId, Oid indexId, Snapshot snapshot)
 	int			save_nestlevel;
 
 	/* Open and lock the parent heap relation */
-	heapRelation = heap_open(heapId, ShareUpdateExclusiveLock);
+	heapRelation = table_open(heapId, ShareUpdateExclusiveLock);
 	/* And the target index relation */
 	indexRelation = index_open(indexId, RowExclusiveLock);
 
@@ -3209,7 +3209,7 @@ validate_index(Oid heapId, Oid indexId, Snapshot snapshot)
 
 	/* Close rels, but keep locks */
 	index_close(indexRelation, NoLock);
-	heap_close(heapRelation, NoLock);
+	table_close(heapRelation, NoLock);
 }
 
 /*
@@ -3531,7 +3531,7 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 	Assert(GetTopTransactionIdIfAny() == InvalidTransactionId);
 
 	/* Open pg_index and fetch a writable copy of the index's tuple */
-	pg_index = heap_open(IndexRelationId, RowExclusiveLock);
+	pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
 	indexTuple = SearchSysCacheCopy1(INDEXRELID,
 									 ObjectIdGetDatum(indexId));
@@ -3591,7 +3591,7 @@ index_set_state_flags(Oid indexId, IndexStateFlagsAction action)
 	/* ... and write it back in-place */
 	heap_inplace_update(pg_index, indexTuple);
 
-	heap_close(pg_index, RowExclusiveLock);
+	table_close(pg_index, RowExclusiveLock);
 }
 
 
@@ -3642,7 +3642,7 @@ reindex_index(Oid indexId, bool skip_constraint_checks, char persistence,
 	 * we only need to be sure no schema or data changes are going on.
 	 */
 	heapId = IndexGetRelation(indexId, false);
-	heapRelation = heap_open(heapId, ShareLock);
+	heapRelation = table_open(heapId, ShareLock);
 
 	/*
 	 * Open the target index relation and get an exclusive lock on it, to
@@ -3756,7 +3756,7 @@ reindex_index(Oid indexId, bool skip_constraint_checks, char persistence,
 		bool		index_bad;
 		bool		early_pruning_enabled = EarlyPruningEnabled(heapRelation);
 
-		pg_index = heap_open(IndexRelationId, RowExclusiveLock);
+		pg_index = table_open(IndexRelationId, RowExclusiveLock);
 
 		indexTuple = SearchSysCacheCopy1(INDEXRELID,
 										 ObjectIdGetDatum(indexId));
@@ -3790,7 +3790,7 @@ reindex_index(Oid indexId, bool skip_constraint_checks, char persistence,
 			CacheInvalidateRelcache(heapRelation);
 		}
 
-		heap_close(pg_index, RowExclusiveLock);
+		table_close(pg_index, RowExclusiveLock);
 	}
 
 	/* Log what we did */
@@ -3803,7 +3803,7 @@ reindex_index(Oid indexId, bool skip_constraint_checks, char persistence,
 
 	/* Close rels, but keep locks */
 	index_close(iRel, NoLock);
-	heap_close(heapRelation, NoLock);
+	table_close(heapRelation, NoLock);
 }
 
 /*
@@ -3855,7 +3855,7 @@ reindex_relation(Oid relid, int flags, int options)
 	 * to prevent schema and data changes in it.  The lock level used here
 	 * should match ReindexTable().
 	 */
-	rel = heap_open(relid, ShareLock);
+	rel = table_open(relid, ShareLock);
 
 	/*
 	 * This may be useful when implemented someday; but that day is not today.
@@ -3869,7 +3869,7 @@ reindex_relation(Oid relid, int flags, int options)
 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 				 errmsg("REINDEX of partitioned tables is not yet implemented, skipping \"%s\"",
 						RelationGetRelationName(rel))));
-		heap_close(rel, ShareLock);
+		table_close(rel, ShareLock);
 		return false;
 	}
 
@@ -3970,7 +3970,7 @@ reindex_relation(Oid relid, int flags, int options)
 	/*
 	 * Close rel, but continue to hold the lock.
 	 */
-	heap_close(rel, NoLock);
+	table_close(rel, NoLock);
 
 	result = (indexIds != NIL);
 
diff --git a/src/backend/catalog/objectaddress.c b/src/backend/catalog/objectaddress.c
index d68e28c9b43..5f66f177d1a 100644
--- a/src/backend/catalog/objectaddress.c
+++ b/src/backend/catalog/objectaddress.c
@@ -1338,7 +1338,7 @@ get_object_address_relobject(ObjectType objtype, List *object,
 
 	/* Extract relation name and open relation. */
 	relname = list_truncate(list_copy(object), nnames - 1);
-	relation = heap_openrv_extended(makeRangeVarFromNameList(relname),
+	relation = table_openrv_extended(makeRangeVarFromNameList(relname),
 									AccessShareLock,
 									missing_ok);
 
@@ -1380,7 +1380,7 @@ get_object_address_relobject(ObjectType objtype, List *object,
 	if (!OidIsValid(address.objectId))
 	{
 		if (relation != NULL)
-			heap_close(relation, AccessShareLock);
+			table_close(relation, AccessShareLock);
 
 		relation = NULL;		/* department of accident prevention */
 		return address;
@@ -2767,7 +2767,7 @@ getObjectDescription(const ObjectAddress *object)
 				HeapTuple	tup;
 				Form_pg_cast castForm;
 
-				castDesc = heap_open(CastRelationId, AccessShareLock);
+				castDesc = table_open(CastRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_cast_oid,
@@ -2790,7 +2790,7 @@ getObjectDescription(const ObjectAddress *object)
 								 format_type_be(castForm->casttarget));
 
 				systable_endscan(rcscan);
-				heap_close(castDesc, AccessShareLock);
+				table_close(castDesc, AccessShareLock);
 				break;
 			}
 
@@ -2888,7 +2888,7 @@ getObjectDescription(const ObjectAddress *object)
 				Form_pg_attrdef attrdef;
 				ObjectAddress colobject;
 
-				attrdefDesc = heap_open(AttrDefaultRelationId, AccessShareLock);
+				attrdefDesc = table_open(AttrDefaultRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_attrdef_oid,
@@ -2915,7 +2915,7 @@ getObjectDescription(const ObjectAddress *object)
 								 getObjectDescription(&colobject));
 
 				systable_endscan(adscan);
-				heap_close(attrdefDesc, AccessShareLock);
+				table_close(attrdefDesc, AccessShareLock);
 				break;
 			}
 
@@ -3000,7 +3000,7 @@ getObjectDescription(const ObjectAddress *object)
 				Form_pg_amop amopForm;
 				StringInfoData opfam;
 
-				amopDesc = heap_open(AccessMethodOperatorRelationId,
+				amopDesc = table_open(AccessMethodOperatorRelationId,
 									 AccessShareLock);
 
 				ScanKeyInit(&skey[0],
@@ -3037,7 +3037,7 @@ getObjectDescription(const ObjectAddress *object)
 				pfree(opfam.data);
 
 				systable_endscan(amscan);
-				heap_close(amopDesc, AccessShareLock);
+				table_close(amopDesc, AccessShareLock);
 				break;
 			}
 
@@ -3050,7 +3050,7 @@ getObjectDescription(const ObjectAddress *object)
 				Form_pg_amproc amprocForm;
 				StringInfoData opfam;
 
-				amprocDesc = heap_open(AccessMethodProcedureRelationId,
+				amprocDesc = table_open(AccessMethodProcedureRelationId,
 									   AccessShareLock);
 
 				ScanKeyInit(&skey[0],
@@ -3087,7 +3087,7 @@ getObjectDescription(const ObjectAddress *object)
 				pfree(opfam.data);
 
 				systable_endscan(amscan);
-				heap_close(amprocDesc, AccessShareLock);
+				table_close(amprocDesc, AccessShareLock);
 				break;
 			}
 
@@ -3100,7 +3100,7 @@ getObjectDescription(const ObjectAddress *object)
 				Form_pg_rewrite rule;
 				StringInfoData rel;
 
-				ruleDesc = heap_open(RewriteRelationId, AccessShareLock);
+				ruleDesc = table_open(RewriteRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_rewrite_oid,
@@ -3125,7 +3125,7 @@ getObjectDescription(const ObjectAddress *object)
 								 NameStr(rule->rulename), rel.data);
 				pfree(rel.data);
 				systable_endscan(rcscan);
-				heap_close(ruleDesc, AccessShareLock);
+				table_close(ruleDesc, AccessShareLock);
 				break;
 			}
 
@@ -3138,7 +3138,7 @@ getObjectDescription(const ObjectAddress *object)
 				Form_pg_trigger trig;
 				StringInfoData rel;
 
-				trigDesc = heap_open(TriggerRelationId, AccessShareLock);
+				trigDesc = table_open(TriggerRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_trigger_oid,
@@ -3163,7 +3163,7 @@ getObjectDescription(const ObjectAddress *object)
 								 NameStr(trig->tgname), rel.data);
 				pfree(rel.data);
 				systable_endscan(tgscan);
-				heap_close(trigDesc, AccessShareLock);
+				table_close(trigDesc, AccessShareLock);
 				break;
 			}
 
@@ -3398,7 +3398,7 @@ getObjectDescription(const ObjectAddress *object)
 				char	   *rolename;
 				char	   *nspname;
 
-				defaclrel = heap_open(DefaultAclRelationId, AccessShareLock);
+				defaclrel = table_open(DefaultAclRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_default_acl_oid,
@@ -3485,7 +3485,7 @@ getObjectDescription(const ObjectAddress *object)
 				}
 
 				systable_endscan(rcscan);
-				heap_close(defaclrel, AccessShareLock);
+				table_close(defaclrel, AccessShareLock);
 				break;
 			}
 
@@ -3525,7 +3525,7 @@ getObjectDescription(const ObjectAddress *object)
 				Form_pg_policy form_policy;
 				StringInfoData rel;
 
-				policy_rel = heap_open(PolicyRelationId, AccessShareLock);
+				policy_rel = table_open(PolicyRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_policy_oid,
@@ -3550,7 +3550,7 @@ getObjectDescription(const ObjectAddress *object)
 								 NameStr(form_policy->polname), rel.data);
 				pfree(rel.data);
 				systable_endscan(sscan);
-				heap_close(policy_rel, AccessShareLock);
+				table_close(policy_rel, AccessShareLock);
 				break;
 			}
 
@@ -3817,7 +3817,7 @@ pg_identify_object(PG_FUNCTION_ARGS)
 	if (is_objectclass_supported(address.classId))
 	{
 		HeapTuple	objtup;
-		Relation	catalog = heap_open(address.classId, AccessShareLock);
+		Relation	catalog = table_open(address.classId, AccessShareLock);
 
 		objtup = get_catalog_object_by_oid(catalog,
 										   get_object_attnum_oid(address.classId),
@@ -3859,7 +3859,7 @@ pg_identify_object(PG_FUNCTION_ARGS)
 			}
 		}
 
-		heap_close(catalog, AccessShareLock);
+		table_close(catalog, AccessShareLock);
 	}
 
 	/* object type */
@@ -4197,7 +4197,7 @@ getConstraintTypeDescription(StringInfo buffer, Oid constroid)
 	HeapTuple	constrTup;
 	Form_pg_constraint constrForm;
 
-	constrRel = heap_open(ConstraintRelationId, AccessShareLock);
+	constrRel = table_open(ConstraintRelationId, AccessShareLock);
 	constrTup = get_catalog_object_by_oid(constrRel, Anum_pg_constraint_oid,
 										  constroid);
 	if (!HeapTupleIsValid(constrTup))
@@ -4212,7 +4212,7 @@ getConstraintTypeDescription(StringInfo buffer, Oid constroid)
 	else
 		elog(ERROR, "invalid constraint %u", constrForm->oid);
 
-	heap_close(constrRel, AccessShareLock);
+	table_close(constrRel, AccessShareLock);
 }
 
 /*
@@ -4321,7 +4321,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				HeapTuple	tup;
 				Form_pg_cast castForm;
 
-				castRel = heap_open(CastRelationId, AccessShareLock);
+				castRel = table_open(CastRelationId, AccessShareLock);
 
 				tup = get_catalog_object_by_oid(castRel, Anum_pg_cast_oid,
 												object->objectId);
@@ -4342,7 +4342,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					*objargs = list_make1(format_type_be_qualified(castForm->casttarget));
 				}
 
-				heap_close(castRel, AccessShareLock);
+				table_close(castRel, AccessShareLock);
 				break;
 			}
 
@@ -4443,7 +4443,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				Form_pg_attrdef attrdef;
 				ObjectAddress colobject;
 
-				attrdefDesc = heap_open(AttrDefaultRelationId, AccessShareLock);
+				attrdefDesc = table_open(AttrDefaultRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_attrdef_oid,
@@ -4470,7 +4470,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 														objname, objargs));
 
 				systable_endscan(adscan);
-				heap_close(attrdefDesc, AccessShareLock);
+				table_close(attrdefDesc, AccessShareLock);
 				break;
 			}
 
@@ -4572,7 +4572,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				char	   *ltype;
 				char	   *rtype;
 
-				amopDesc = heap_open(AccessMethodOperatorRelationId,
+				amopDesc = table_open(AccessMethodOperatorRelationId,
 									 AccessShareLock);
 
 				ScanKeyInit(&skey[0],
@@ -4611,7 +4611,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				pfree(opfam.data);
 
 				systable_endscan(amscan);
-				heap_close(amopDesc, AccessShareLock);
+				table_close(amopDesc, AccessShareLock);
 				break;
 			}
 
@@ -4626,7 +4626,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				char	   *ltype;
 				char	   *rtype;
 
-				amprocDesc = heap_open(AccessMethodProcedureRelationId,
+				amprocDesc = table_open(AccessMethodProcedureRelationId,
 									   AccessShareLock);
 
 				ScanKeyInit(&skey[0],
@@ -4665,7 +4665,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				pfree(opfam.data);
 
 				systable_endscan(amscan);
-				heap_close(amprocDesc, AccessShareLock);
+				table_close(amprocDesc, AccessShareLock);
 				break;
 			}
 
@@ -4675,7 +4675,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				HeapTuple	tup;
 				Form_pg_rewrite rule;
 
-				ruleDesc = heap_open(RewriteRelationId, AccessShareLock);
+				ruleDesc = table_open(RewriteRelationId, AccessShareLock);
 
 				tup = get_catalog_object_by_oid(ruleDesc, Anum_pg_rewrite_oid,
 												object->objectId);
@@ -4692,7 +4692,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				if (objname)
 					*objname = lappend(*objname, pstrdup(NameStr(rule->rulename)));
 
-				heap_close(ruleDesc, AccessShareLock);
+				table_close(ruleDesc, AccessShareLock);
 				break;
 			}
 
@@ -4702,7 +4702,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				HeapTuple	tup;
 				Form_pg_trigger trig;
 
-				trigDesc = heap_open(TriggerRelationId, AccessShareLock);
+				trigDesc = table_open(TriggerRelationId, AccessShareLock);
 
 				tup = get_catalog_object_by_oid(trigDesc, Anum_pg_trigger_oid,
 												object->objectId);
@@ -4719,7 +4719,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				if (objname)
 					*objname = lappend(*objname, pstrdup(NameStr(trig->tgname)));
 
-				heap_close(trigDesc, AccessShareLock);
+				table_close(trigDesc, AccessShareLock);
 				break;
 			}
 
@@ -4964,7 +4964,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				char	   *schema;
 				char	   *username;
 
-				defaclrel = heap_open(DefaultAclRelationId, AccessShareLock);
+				defaclrel = table_open(DefaultAclRelationId, AccessShareLock);
 
 				ScanKeyInit(&skey[0],
 							Anum_pg_default_acl_oid,
@@ -5030,7 +5030,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				}
 
 				systable_endscan(rcscan);
-				heap_close(defaclrel, AccessShareLock);
+				table_close(defaclrel, AccessShareLock);
 				break;
 			}
 
@@ -5075,7 +5075,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				HeapTuple	tup;
 				Form_pg_policy policy;
 
-				polDesc = heap_open(PolicyRelationId, AccessShareLock);
+				polDesc = table_open(PolicyRelationId, AccessShareLock);
 
 				tup = get_catalog_object_by_oid(polDesc, Anum_pg_policy_oid,
 												object->objectId);
@@ -5092,7 +5092,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				if (objname)
 					*objname = lappend(*objname, pstrdup(NameStr(policy->polname)));
 
-				heap_close(polDesc, AccessShareLock);
+				table_close(polDesc, AccessShareLock);
 				break;
 			}
 
@@ -5153,7 +5153,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 				char	   *transformLang;
 				char	   *transformType;
 
-				transformDesc = heap_open(TransformRelationId, AccessShareLock);
+				transformDesc = table_open(TransformRelationId, AccessShareLock);
 
 				tup = get_catalog_object_by_oid(transformDesc,
 												Anum_pg_transform_oid,
@@ -5177,7 +5177,7 @@ getObjectIdentityParts(const ObjectAddress *object,
 					*objargs = list_make1(pstrdup(transformLang));
 				}
 
-				heap_close(transformDesc, AccessShareLock);
+				table_close(transformDesc, AccessShareLock);
 			}
 			break;
 
diff --git a/src/backend/catalog/partition.c b/src/backend/catalog/partition.c
index 83ec22cb0fd..62d1ec60ba5 100644
--- a/src/backend/catalog/partition.c
+++ b/src/backend/catalog/partition.c
@@ -55,14 +55,14 @@ get_partition_parent(Oid relid)
 	Relation	catalogRelation;
 	Oid			result;
 
-	catalogRelation = heap_open(InheritsRelationId, AccessShareLock);
+	catalogRelation = table_open(InheritsRelationId, AccessShareLock);
 
 	result = get_partition_parent_worker(catalogRelation, relid);
 
 	if (!OidIsValid(result))
 		elog(ERROR, "could not find tuple for parent of relation %u", relid);
 
-	heap_close(catalogRelation, AccessShareLock);
+	table_close(catalogRelation, AccessShareLock);
 
 	return result;
 }
@@ -120,11 +120,11 @@ get_partition_ancestors(Oid relid)
 	List	   *result = NIL;
 	Relation	inhRel;
 
-	inhRel = heap_open(InheritsRelationId, AccessShareLock);
+	inhRel = table_open(InheritsRelationId, AccessShareLock);
 
 	get_partition_ancestors_worker(inhRel, relid, &result);
 
-	heap_close(inhRel, AccessShareLock);
+	table_close(inhRel, AccessShareLock);
 
 	return result;
 }
@@ -310,7 +310,7 @@ update_default_partition_oid(Oid parentId, Oid defaultPartId)
 	Relation	pg_partitioned_table;
 	Form_pg_partitioned_table part_table_form;
 
-	pg_partitioned_table = heap_open(PartitionedRelationId, RowExclusiveLock);
+	pg_partitioned_table = table_open(PartitionedRelationId, RowExclusiveLock);
 
 	tuple = SearchSysCacheCopy1(PARTRELID, ObjectIdGetDatum(parentId));
 
@@ -323,7 +323,7 @@ update_default_partition_oid(Oid parentId, Oid defaultPartId)
 	CatalogTupleUpdate(pg_partitioned_table, &tuple->t_self, tuple);
 
 	heap_freetuple(tuple);
-	heap_close(pg_partitioned_table, RowExclusiveLock);
+	table_close(pg_partitioned_table, RowExclusiveLock);
 }
 
 /*
diff --git a/src/backend/catalog/pg_aggregate.c b/src/backend/catalog/pg_aggregate.c
index fe953c95ae5..cc3806e85d5 100644
--- a/src/backend/catalog/pg_aggregate.c
+++ b/src/backend/catalog/pg_aggregate.c
@@ -639,7 +639,7 @@ AggregateCreate(const char *aggName,
 	/*
 	 * Okay to create the pg_aggregate entry.
 	 */
-	aggdesc = heap_open(AggregateRelationId, RowExclusiveLock);
+	aggdesc = table_open(AggregateRelationId, RowExclusiveLock);
 	tupDesc = aggdesc->rd_att;
 
 	/* initialize nulls and values */
@@ -680,7 +680,7 @@ AggregateCreate(const char *aggName,
 	tup = heap_form_tuple(tupDesc, values, nulls);
 	CatalogTupleInsert(aggdesc, tup);
 
-	heap_close(aggdesc, RowExclusiveLock);
+	table_close(aggdesc, RowExclusiveLock);
 
 	/*
 	 * Create dependencies for the aggregate (above and beyond those already
diff --git a/src/backend/catalog/pg_collation.c b/src/backend/catalog/pg_collation.c
index 57ce7d7205c..ea6777f902e 100644
--- a/src/backend/catalog/pg_collation.c
+++ b/src/backend/catalog/pg_collation.c
@@ -107,7 +107,7 @@ CollationCreate(const char *collname, Oid collnamespace,
 	}
 
 	/* open pg_collation; see below about the lock level */
-	rel = heap_open(CollationRelationId, ShareRowExclusiveLock);
+	rel = table_open(CollationRelationId, ShareRowExclusiveLock);
 
 	/*
 	 * Also forbid a specific-encoding collation shadowing an any-encoding
@@ -129,12 +129,12 @@ CollationCreate(const char *collname, Oid collnamespace,
 	{
 		if (quiet)
 		{
-			heap_close(rel, NoLock);
+			table_close(rel, NoLock);
 			return InvalidOid;
 		}
 		else if (if_not_exists)
 		{
-			heap_close(rel, NoLock);
+			table_close(rel, NoLock);
 			ereport(NOTICE,
 					(errcode(ERRCODE_DUPLICATE_OBJECT),
 					 errmsg("collation \"%s\" already exists, skipping",
@@ -198,7 +198,7 @@ CollationCreate(const char *collname, Oid collnamespace,
 	InvokeObjectPostCreateHook(CollationRelationId, oid, 0);
 
 	heap_freetuple(tup);
-	heap_close(rel, NoLock);
+	table_close(rel, NoLock);
 
 	return oid;
 }
@@ -217,7 +217,7 @@ RemoveCollationById(Oid collationOid)
 	SysScanDesc scandesc;
 	HeapTuple	tuple;
 
-	rel = heap_open(CollationRelationId, RowExclusiveLock);
+	rel = table_open(CollationRelationId, RowExclusiveLock);
 
 	ScanKeyInit(&scanKeyData,
 				Anum_pg_collation_oid,
@@ -236,5 +236,5 @@ RemoveCollationById(Oid collationOid)
 
 	systable_endscan(scandesc);
 
-	heap_close(rel, RowExclusiveLock);
+	table_close(rel, RowExclusiveLock);
 }
